
<template>
  <div>
    <ErrorAlert v-show="isError"></ErrorAlert>
    <CheckboxError v-show="isCheckBoxError"></CheckboxError>
    <Loading v-if="isLoading"></Loading>

    <v-form
      v-else
      :v-model="valid"
      ref="form"
      lazy-validation
      @submit="submitRepairForm"
    >
      <v-card>
        <v-card-text>
          <div align="start" class="pa-4">
            <h2 class="mb-5">แบบฟอร์มแจ้งซ่อม</h2>
            <div class="py-3">
              <hr />
            </div>
            <v-row>
              <v-col cols="6" sm="4" md="3">
                <v-subheader id="header">LockerCode : </v-subheader>
              </v-col>
              <v-col cols="6" sm="6" md="4">
                <v-text-field
                  filled
                  :label="getLockerCode"
                  height="50px"
                  disabled
                ></v-text-field>
              </v-col>
            </v-row>
            <label class="font-weight-bold">
              เลือกช่องล็อคเกอร์ที่ต้องการซ่อม
            </label>
            <div class="pa-4">
              <CheckboxLkRoomList></CheckboxLkRoomList>
            </div>
            <div>
              <v-btn type="submit" color="primary" depressed medium
                >ยืนยันการส่งฟอร์ม</v-btn
              >
            </div>
          </div>
        </v-card-text>
      </v-card>
      <ConfirmDialog
        :isDialog="isConfirmDialog"
        @isConfirm="isConfirm"
      ></ConfirmDialog>
      <LoadingApi :isDialog="isApiLoading"></LoadingApi>
      <ResultApi :isDialog="isCompleteApiAdd" :isError="isError"></ResultApi>
    </v-form>
  </div>
</template>

<script>
import Loading from "../../../components/loading/Loading";
import CheckboxLkRoomList from "../../../components/repair/CheckBoxLkRoomList";
import CheckboxError from "../../../components/repair/CheckBoxError";
import ErrorAlert from "../../../components/loading/ErrorAlert";
import ConfirmDialog from "../../../components/repair/ConfirmDialog";
import LoadingApi from "../../../components/repair/LoadingApi";
import ResultApi from "../../../components/repair/ResultApi";
export default {
  components: {
    Loading,
    CheckboxLkRoomList,
    ErrorAlert,
    CheckboxError,
    ConfirmDialog,
    LoadingApi,
    ResultApi,
  },
  data() {
    return {
      valid: true,
      isCheckBoxError: false,
      locker: {},
      isConfirmDialog: false,
      isApiProcess: false,
      isCompleteApiAdd: false,
    };
  },
  computed: {
    isLoading() {
      return this.$store.getters["repair/loading"] && !this.isApiProcess;
    },
    isApiLoading() {
      return this.$store.getters["repair/loading"] && this.isApiProcess;
    },
    isError() {
      return this.$store.getters["repair/error"];
    },
    getLockerCode() {
      return this.locker.lockerCode;
    },
  },
  methods: {
    submitRepairForm(e) {
      e.preventDefault();
      let lkRoomIdList = this.$store.getters["repair/lkRoomIdList"];
      if (lkRoomIdList.length > 0) {
        this.isCheckBoxError = false;
        this.isConfirmDialog = true;
      } else {
        this.isCheckBoxError = true;
        this.isConfirmDialog = false;
      }
    },
    async isConfirm(value) {
      this.isConfirmDialog = value;
      if (value === true) {
        this.isConfirmDialog = false;
        var data = {
          LkRoomIdList: this.$store.getters["repair/lkRoomIdList"],
          accountId: localStorage.getItem("accountId"),
        };
      }
      this.isApiProcess = true;
      await this.$store.dispatch("repair/createReportForm", data);
      this.isCompleteApiAdd = true;

      this.isApiProcess = false;
    },
  },

  async created() {
    if (this.$route.params.locker === undefined) {
      this.$router.replace({ name: "locker-list" });
    } else {
      this.$store.dispatch(
        "repair/initialLockerToRepair",
        this.$route.params.locker
      );

      this.locker = this.$store.getters["repair/repairLocker"];

      await this.$store.dispatch(
        "repair/getAllLockerRoomByLockerId",
        this.locker.lockerId
      );
    }
  },

  mounted() {
    // if back button is pressed
    window.onpopstate = this.$store.dispatch("repair/clearState");
  },
};
</script>

<style>
#header {
  font-size: large;
}
</style>